<template>
    <main id="js-page-content" role="main" class="page-content">
        <ol class="breadcrumb page-breadcrumb">
            <li class="breadcrumb-item"> <router-link to="/index">Dashboard</router-link> </li>
            <li class="breadcrumb-item active">Roles</li>
        </ol>
        <div class="subheader">
            <h1 class="subheader-title">
                <i class='subheader-icon fal fa-tags'></i> Roles<span class='fw-300'></span>
            </h1>
            <div v-if="findPermission('role','createAny') || user_role=='admin'" class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center mr-3">
                    <button class="btn btn-success" @click="openModal()">
                        <i class="fas fa-user-plus"></i> Add Roles
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
        </div>
        <div class="row text-center">
            <div class="row">
                <div class="col-xl-12 col-md-12">
                    <div id="panel-1" class="panel">
                        <div class="panel-hdr">
                            <h2>
                                Permission <span class="fw-300"><i>List</i></span>
                            </h2>
                            <div class="panel-toolbar">
                                <button class="btn btn-panel" data-action="panel-collapse" data-toggle="tooltip" data-offset="0,10" data-original-title="Collapse"></button>
                                <button class="btn btn-panel" data-action="panel-fullscreen" data-toggle="tooltip" data-offset="0,10" data-original-title="Fullscreen"></button>
                            </div>
                        </div>
                        <div class="panel-container show">
                            <div class="panel-content">
                                <!-- datatable start -->
                                <table id="dt-basic-example" class="table table-bordered table-hover table-striped w-100">
                                    <thead>
                                        <tr>
                                            <th rowspan="2">S.N.</th>
                                            <th style="width:150px" rowspan="2">Permission Level</th>
                                            <th style="width:300px" colspan="2">Permissions</th>
                                            <th v-if="findPermission('role','updateAny') || findPermission('role','deleteAny') || user_role=='admin'" rowspan="2">Operations</th>
                                        </tr>
                                        <tr>
                                            <th style="width:150px">Action</th>
                                            <th style="width:150px">Resource</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr v-for="(role,index) in roles" :key="role.id">
                                            <td> {{index+1}} </td>
                                            <td><b> {{role.name}} </b> </td>
                                            <td>
                                                <tr v-for="(permission) in role.permissions" :key="permission._id" style="width:150px">
                                                    {{permission.action}}
                                                </tr>
                                            </td>
                                            <td>
                                                <tr v-for="permission in role.permissions" :key="permission._id" style="width:150px">
                                                    {{permission.resource}}
                                                </tr>
                                            </td>
                                            <td>
                                                <button v-if="findPermission('role','updateAny') || user_role=='admin'" class="btn btn-warning mr-3" style="width:80px" @click="openModal(index)"> Edit</button>
                                                <button v-if="findPermission('role','deleteAny') || user_role=='admin'" class="btn btn-danger mr-3" style="width:80px" @click="deleteRole(role._id)"> Delete</button>
                                                <button  v-if="findPermission('role','updateAny') || user_role=='admin'" class="btn btn-info" @click="redirectTo(role.name)"> Show Users</button>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                                <!-- datatable end -->
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- modal -->
        <div class="modal fade" id="roleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content">
                <div class="modal-header">
                    <h5 v-if="editMode" class="modal-title" id="exampleModalLongTitle">Edit Role</h5>
                    <h5 v-if="!editMode" class="modal-title" id="exampleModalLongTitle">Add Role</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label class="form-label" for="name">Name</label>
                        <input type="text" v-model="role.name" name="name" class="form-control" 
                            :class="{ 'is-invalid': role.errors.has('name') }" id="name" 
                            placeholder="Enter the name" value="">
                        <has-error :form="role" field="name"></has-error>
                    </div>
                    <div class="form-group">
                        <label class="form-label" for="previleges">Previleges</label>
                        <v-select :options="previlegeOptions" @input="selectPrevilegeDoc">
                            <template slot="previlegeOption" slot-scope="previlegeOption">
                                {{ previlegeOption.label }}
                            </template>
                        </v-select>
                        <div class="mt-3 ml-2" v-for="(value,index) in previleges" :key="index">
                            <div class="row">
                                <div class="col-md-4">
                                    {{ value.label }}
                                </div>
                                <div class="col-md-6">
                                    <button class="btn btn-xs btn-danger" @click="removePrevilege(value)">Remove</button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="form-label" for="pages">Page access</label>
                        <v-select :options="pageOptions" @input="selectPageDoc">
                            <template slot="pageOption" slot-scope="pageOption">
                                {{ pageOption.label }}
                            </template>
                        </v-select>
                        <div class="mt-3 ml-2" v-for="(value,index) in pages" :key="index">
                            <div class="row">
                                <div class="col-md-3">
                                    {{ value.label }}
                                </div>
                                <div class="col-md-6">
                                    <button class="btn btn-xs btn-danger" @click="removePage(value)">Remove</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary" v-if="editMode" @click="editRole()">Save changes</button>
                    <button type="button" class="btn btn-primary" v-if="!editMode" @click="addRole()">Add</button>
                </div>
                </div>
            </div>
        </div>
    </main>
</template>

<script>
    import vSelect from "vue-select";

    export default {
        components: {
            vSelect
        },
        name: 'Roles',
        data() {
            return {
                editMode:false,
                previlegeOptions: [],
                pageOptions:[],
                permission: {},
                previleges: [],
                pages: [],
                role: new this.$Form( {
                    _id:'',
                    name: '',
                    previleges: [],
                    pages: [],
                    permissions: []
                }),
                roles: [],
                user_role:''
            }
        },

        methods:
        {   
            selectPrevilegeDoc (doc) {
                this.previleges.push(doc)
                this.role.previleges.push(doc.value);
                this.previlegeOptions = this.previlegeOptions.filter(option => option != doc)
            },
            
            removePrevilege (doc) {
                this.previlegeOptions.push(doc);
                this.role.previleges = this.role.previleges.filter(value => value != doc.value)
                this.previleges = this.previleges.filter(value => value != doc)
            },

            selectPageDoc (doc) {
                this.pages.push(doc)
                this.role.pages.push(doc.value);
                this.pageOptions = this.pageOptions.filter(option => option != doc)
            },
            
            removePage (doc) {
                this.pageOptions.push(doc);
                this.role.pages = this.role.pages.filter(value => value != doc.value)
                this.pages = this.pages.filter(value => value != doc)
            },

            fetchRoles() {
                this.$store.dispatch('role/allRole')
                .then(() => {
                    this.roles = this.$store.getters['role/roles']
                })
            },

            addRole() {
                this.role.pages.forEach(page => {
                    this.role.previleges.forEach(previlege => {
                        this.permission= {"action": previlege,"resource" : page}
                        this.role.permissions.push(this.permission)
                    })
                });
                this.$store.dispatch('role/addRole', this.role)
                .then(() => {
                    this.$$('#roleModal').modal('hide')
                    this.redirectTo(this.role.name)
                })
            },
            
            redirectTo(role){
                this.$router.push(`/addUserToRole/${role}`)
            },
            
            openModal(index=null){
                this.previlegeOptions = [
                    { label:"Can view own", value:'readOwn' },
                    { label:"Can view any", value:'readAny' },
                    { label:"Can update own", value:'updateOwn' },
                    { label:"Can update any", value:'updateAny' },
                    { label:"Can delete own", value:'deleteOwn' },
                    { label:"Can delete any", value:'deleteAny' },
                    { label:"Can create own", value:'createOwn' },
                    { label:"Can create any", value:'createAny' }]
                this.pageOptions = [
                    { label:"Profile", value:'profile' },
                    { label:"Device", value:'device' },
                    { label:"Role", value:'role' },
                    { label:"Survey", value:'survey' }]
                this.previleges = []
                this.pages = []
                this.role.clear()
                this.role.reset()
                if (index!=null){
                    this.editMode = true
                    this.role._id=this.roles[index]._id
                    this.role.name = this.roles[index].name
                    this.roles[index].permissions.forEach(permission => {
                        if(!this.role.previleges.includes(permission.action)){
                            let per = this.previlegeOptions.find(item => item.value == permission.action)
                            this.previleges.push(per)
                            this.role.previleges.push(permission.action)
                            this.previlegeOptions = this.previlegeOptions.filter(option => option != per)
                        }
                        if(!this.role.pages.includes(permission.resource)){
                            let per = this.pageOptions.find(item => item.value == permission.resource)
                            this.pages.push(per)
                            this.role.pages.push(permission.resource)
                            this.pageOptions = this.pageOptions.filter(option => option != per)
                        }
                    })
                }
                this.$$('#roleModal').modal('show')
            },

            editRole() {
                this.role.pages.forEach(page => {
                    this.role.previleges.forEach(previlege => {
                        this.permission= {"action": previlege,"resource" : page}
                        this.role.permissions.push(this.permission)
                    })
                });
                var data = {
                    "id": this.role._id,
                    "name": this.role.name,
                    "permissions" : this.role.permissions
                }
                this.$store.dispatch('role/editRole', data)
                .then(() => {
                    this.editMode = false
                    this.$$('#roleModal').modal('hide')
                    this.role.clear()
                    this.role.reset()
                    this.fetchRoles()
                })
            },

            deleteRole(id) {
                this.$Swal.fire({
                    title: 'Are you sure?',
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Yes, delete it!',
                    showLoaderOnConfirm: true,
                    preConfirm: () => {
                        this.$store.dispatch('role/deleteRole', id)
                        .then(() => {
                            this.fetchRoles()
                        })
                    }
                })                
            },
            findPermission(resource,action){
                if(this.user_role!='user' && this.user_role!='admin'){
                    if(this.user_role.permissions.find(item => item.resource == resource && item.action == action)){
                        return true
                    }
                    else{
                        return false
                    }
                }
            }
        },

        created() {
            this.fetchRoles()
            this.user_role = JSON.parse(localStorage.getItem("role"))
        }
    }
</script>

<style scoped>
</style>
